# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without jdk6

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'
%define _with_repolib 1

%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/apache-avalon-logkit/1.2-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src
%define short_name      logkit
%define     camelcase_short_name      LogKit
%define name            avalon-%{short_name}
%define version         1.2
%define release         2jpp.el4ep1.3
%define section         free

Name:           avalon-logkit
Version:        1.2
Release:        8.2.1%{?dist}
Epoch:          0
Summary:        Java logging toolkit
License:        ASL 2.0
Group:          Development/Libraries/Java
#Distribution:  JPackage
#Vendor:                JPackage Project
Url:            http://avalon.apache.org/%{short_name}/
Source0:     http://archive.apache.org/dist/avalon/logkit/LogKit-1.2-src.tar.gz
Patch0:         %{name}-build.patch
Patch3:         %{name}-jdk6.patch

Patch1:      %{name}-javadoc.patch
Patch2:      %{name}-notarget.patch
Source1:        avalon-logkit-component-info.xml
Source2:        logkit-1.2.pom
Source3:        avalon-logkit-upload.sh
Requires:       avalon-framework >= 0:4.1.4
Requires:       servlet25
Requires:       jms
Requires:       jdbc-stdext
Requires(post):  jpackage-utils >= 0:1.5
Requires(postun):  jpackage-utils >= 0:1.5
BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:  ant
BuildRequires:  glassfish-javamail
BuildRequires:  junit
BuildRequires:  log4j
BuildRequires:  avalon-framework >= 0:4.1.4
BuildRequires:  servlet25
BuildRequires:  jms

# maven is used to install pom and upload script into repolib for RHEL-6 build
BuildRequires:  maven2
BuildRequires:  maven-deploy-plugin
#BuildRequires:  jdbc-stdext
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot

%description
LogKit is a logging toolkit designed for secure performance orientated
logging in applications. To get started using LogKit, it is recomended
that you read the whitepaper and browse the API docs.

%if %{with_repolib}
%package         repolib
Summary:         Artifacts to be uploaded to a repository library
Group:  Development/Libraries/Java

%description     repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%prep
%setup -q -n %{camelcase_short_name}-%{version}
%patch0
%patch1 -p1
%patch2 -p1

%if %with jdk6
%patch3 -b .sav0
%endif

# remove all binary libs
find . -name "*.jar" -exec rm -f {} \;


tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE1}

#Update groupId to match with r.j.o/m2-brew
cp -pr %{SOURCE2} pom.xml
sed -i -e 's:<groupId>logkit</groupId>:<groupId>apache-avalon-logkit</groupId>:' pom.xml

%build
export CLASSPATH=%(build-classpath log4j glassfish-javamail/mailapi jms servlet avalon-framework junit):$PWD/build/classes
ant clean jar javadocs

%install
rm -rf $RPM_BUILD_ROOT
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 build/lib/%{short_name}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} ${jar/-%{version}/}; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -p -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap %{short_name} %{short_name} %{version} JPP %{name}
%add_to_maven_depmap apache-avalon-logkit %{short_name} %{version} JPP %{name}

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}
cp -pr build/javadocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %{with_repolib}
        install -d -m 755 $RPM_BUILD_ROOT%{repodir}
        install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
        install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{repodir}/component-info.xml
        install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
        install -m 755 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
        install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
        cp build/lib/%{short_name}.jar $RPM_BUILD_ROOT%{repodirlib}
		cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom $RPM_BUILD_ROOT%{repodirlib}/logkit.pom
		install -p -m 755 %{SOURCE3} %{buildroot}%{repodir}/upload.sh
		pushd %{buildroot}%{repodir}
			./upload.sh %{buildroot}/usr/share/java/repository.jboss.com/maven2-brew/
		popd		
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(0644,root,root,0755)
%doc KEYS LICENSE
%{_javadir}*/%{name}-%{version}.jar
%{_javadir}*/%{name}.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Mon Apr 25 2011 Yong Yang <yyang@redhat.com> 0:1.2-8.2.1
- Merge with RHEL-6

* Fri Jan 21 2011 Permaine Cheung <pcheung@redhat.com> 0:1.2-4.3.6
- Add depmap for groupId apache-avalon-logkit

* Fri Jan 21 2011 Permaine Cheung <pcheung@redhat.com> 0:1.2-4.3.5
- Update groupId to apache-avalon-logkit in pom

* Mon Dec 06 2010 Weinan Li <weli@redhat.com> 0:1.2-4.3.4
- Fix depmap
- Add pom file
- Fix files section

* Mon Nov 22 2010 Weinan Li <weli@redhat.com> 0:1.2-4.3.3
- Add upload script into repolib for signed jars
- Add BR maven2
- Add BR maven-deploy-plugin

* Wed Nov 17 2010 Weinan Li <weli@redhat.com> 0:1.2-4.3.2
- Rebuild for RHEL6
- Add signed jars to files and repolib section

* Mon Jun 07 2010 Martha Benitez <mbenitez@redhat.com> 0:1.2-4.3.1
- Add conditional macro jdk6
- Add jdk6 patch
- Rebuild for generating signed jar

* Fri May 14 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.2-4.1.3
- rebuilt

* Tue Apr 20 2010 Hui Wang <huwang@redhat.com> 0:1.2-4.1.3
- Rebuild with jdk5 to generate signed jar

* Mon Apr 19 2010 Luiz Barreiros <gbarreir@redhat.com> 0:1.2-4.1.2
- Rebuild

* Fri Feb 05 2010 Yiqiao Wang <yiwang@redhat.com> 0:1.2-4.1.1
- Merge from RHEL-4

* Tue Jun 23 2009 Martha Benitez <mbenitez@redhat.com> 0:1.2-4.1
- Change BR javamail to glassfish-javamail
- Comment out jdbc-stdext and remove it from classpath
- Complete patch0 line

* Tue May 27 2008 Permaine Cheung <pcheung@redhat.com> 0:1.2-4
- First JPP5 build

* Tue Mar 13 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:1.2-2jpp.ep1.2
- Fix repolib location

* Tue Mar 13 2007 Fernando Nasser <fnasser@redhat.com> 0:1.2-2jpp.ep1.1
- New repolib location

* Mon Feb 19 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:1.2-2jpp.el4ep1.2
- Add -brew suffix

* Thu Feb 15 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:1.2-2jpp.el4ep1.1
- Add repolib support

* Wed Nov 16 2005 Fernando Nasser <fnasser@redhat.com> 0:1.2-2jpp_4rh
- Require javamail alternative

* Mon Nov 15 2004 Fernando Nasser <fnasser@redhat.com> 0:1.2-2jpp_2rh
- Rebuild

* Fri Mar  5 2004 Frank Ch. Eigler <fche@redhat.com> 0:1.2-2jpp_1rh
- RH vacuuming

* Fri May 09 2003 David Walluck <david@anti-microsoft.org> 0:1.2-2jpp
- update for JPackage 1.5

* Fri Mar 21 2003 Nicolas Mailhot <Nicolas.Mailhot (at) JPackage.org> 1.2-1jpp
- For jpackage-utils 1.5

* Tue May 07 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0.1-4jpp 
- hardcoded distribution and vendor tag
- group tag again

* Thu May 2 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0.1-3jpp 
- distribution tag
- group tag

* Mon Mar 18 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0.1-2jpp 
- generic servlet support

* Sun Feb 03 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0.1-1jpp 
- 1.0.1
- versioned dir for javadoc
- no dependencies for and javadoc package
- adaptation for new servlet3 package
- drop j2ee package
- regenerated the patch
- section package

* Wed Dec 5 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0-4jpp
- javadoc into javadoc package
- Requires and BuildRequires servletapi3 >= 3.2.3-2
- regenerated the patch

* Wed Nov 21 2001 Christian Zoffoli <czoffoli@littlepenguin.org> 1.0-3jpp
- changed extension --> jpp

* Tue Nov 20 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0-2jpp
- non-free extension classes back in original archive
- removed packager tag

* Sun Oct 28 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0-1jpp
- 1.0

* Tue Oct 9 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0-0.b5.2jpp
- non-free extension as additional package

* Sat Oct 6 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0-0.b5.1jpp
- 1.0b5
- first unified release
- used original tarball

* Mon Sep 10 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0-0.b4.1mdk
- first Mandrake release
